VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "GifMakerByTheTrick"
   ClientHeight    =   5565
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   6435
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   371
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   429
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtThreshold 
      Alignment       =   2  'Center
      Height          =   300
      Left            =   5310
      MaxLength       =   3
      TabIndex        =   8
      Text            =   "128"
      Top             =   3510
      Width           =   1050
   End
   Begin VB.TextBox txtLoop 
      Alignment       =   2  'Center
      Height          =   300
      Left            =   5310
      MaxLength       =   5
      TabIndex        =   10
      Text            =   "0"
      Top             =   4080
      Width           =   1050
   End
   Begin VB.TextBox txtInterval 
      Alignment       =   2  'Center
      Height          =   300
      Left            =   5310
      MaxLength       =   5
      TabIndex        =   6
      Text            =   "100"
      Top             =   2940
      Width           =   1050
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save"
      Height          =   495
      Left            =   5265
      TabIndex        =   4
      Top             =   2145
      Width           =   1125
   End
   Begin VB.CommandButton cmdRemove 
      Caption         =   "Remove"
      Height          =   495
      Left            =   5265
      TabIndex        =   3
      Top             =   1620
      Width           =   1125
   End
   Begin VB.CommandButton cmdDown 
      Caption         =   "Down"
      Height          =   495
      Left            =   5265
      TabIndex        =   2
      Top             =   1110
      Width           =   1125
   End
   Begin VB.CommandButton cmdUp 
      Caption         =   "Up"
      Height          =   495
      Left            =   5265
      TabIndex        =   1
      Top             =   600
      Width           =   1125
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      Default         =   -1  'True
      Height          =   495
      Left            =   5250
      TabIndex        =   0
      Top             =   90
      Width           =   1125
   End
   Begin VB.Label lblThreshold 
      Caption         =   "&Threshold"
      Height          =   300
      Left            =   5325
      TabIndex        =   7
      Top             =   3255
      Width           =   1035
   End
   Begin VB.Label lblLoop 
      Caption         =   "&Loop count"
      Height          =   300
      Left            =   5325
      TabIndex        =   9
      Top             =   3825
      Width           =   1035
   End
   Begin VB.Label lblInterval 
      Caption         =   "&Interval"
      Height          =   300
      Left            =   5325
      TabIndex        =   5
      Top             =   2685
      Width           =   1035
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'  frmMain.frm -     
'     (The trick), 2014

Option Explicit

Dim token As Long, gi As GdiplusStartupInput                        '   GDI+
Dim LastValidInterval As Long, LastValidLoopCount As Long           '     
Dim LastValidAlpha As Long                                          '  - (0-)

Private Const CltSpacing = 5                                        '   

'    
Public Sub lstImage_SelChange()
    txtInterval.Text = CStr(List(ListIndex).TimeMS)
    txtThreshold.Text = CStr(List(ListIndex).AlphaThreshold)
End Sub
'   ""
Private Sub cmdAdd_Click()
    Dim img As Long, nam() As String, itm As ListItem, thumb As Long, iw As Long, ih As Long, a As Single, _
        d As Single, ct As Long, i As Long, pth As String, fnam As String, v As Long
    
    '   
    nam() = GetOpenFile(Me.hwnd, ct)
    If ct Then
        '  
        pth = nam(0)
        '    
        For i = 1 To ct - 1
            '    
            fnam = pth & "\" & nam(i)
            '  
            If GdipLoadImageFromFile(ByVal StrPtr(fnam), img) = 0 Then
                '  
                GdipGetImageWidth img, iw: GdipGetImageHeight img, ih
                '  
                If iw < 640 Or ih < 640 Then
                    '   
                    itm.Width = iw: itm.Height = ih
                    '   
                    If iw > 0 And ih > 0 Then
                        a = iw / ih
                        If a > 1 Then
                            d = 94 / iw
                            iw = iw * d
                            ih = iw / a
                        Else
                            d = 94 / ih
                            ih = ih * d
                            iw = ih * a
                        End If
                    End If
                    '  
                    GdipGetImageThumbnail img, iw, ih, thumb
                    '    
                    itm.FileName = fnam
                    itm.img = thumb
                    itm.TimeMS = LastValidInterval
                    itm.AlphaThreshold = LastValidAlpha
                    '    
                    AddItem itm
                    '   
                    GdipDisposeImage img
                Else
                    MsgBox "Image size too big (max 640x640)" & vbNewLine & fnam
                    GdipDisposeImage img
                End If
            Else
                MsgBox "Error open file" & vbNewLine & fnam
            End If
        Next
    End If
End Sub
'  
Private Sub cmdDown_Click()
    Dim i As Long
    i = ListIndex
    If i < ListCount - 1 Then
        Swap i, i + 1
        ListIndex = i + 1
    End If
End Sub
' 
Private Sub cmdRemove_Click()
    Remove ListIndex
End Sub
' 
Private Sub cmdSave_Click()
    Dim nam As String, img As Long, i As Long, mimg As Long, itm As ListItem, cls As CLSID, ct As Long
    Dim PropItem(2) As PropertyItem, interval() As Long, enc As EncoderParameters, encvalue As Long, TrIdx As Long
    Dim IStream As IUnknown, pt As Long, sz As Long, hMem As Long, hFile As Long
    '    - 
    If ListCount = 0 Then Exit Sub
    '    
    nam = GetSaveFile(Me.hwnd)
    '    ,  
    If Len(nam) = 0 Then Exit Sub
    '  CLSID 
    If GetEncoderClsid("image/gif", cls) = -1 Then
        MsgBox "Codec not found"
        Exit Sub
    End If
    '   GIF-
    '  
    ReDim interval(ListCount - 1)
    PropItem(0).propId = PropertyTagFrameDelay
    PropItem(0).Length = ListCount * 4
    PropItem(0).type = PropertyTagTypeLong
    PropItem(0).Value = VarPtr(interval(0))
    '  
    
    PropItem(1).propId = PropertyTagLoopCount
    PropItem(1).Length = 2
    PropItem(1).type = PropertyTagTypeShort
    PropItem(1).Value = VarPtr(LastValidLoopCount)

    PropItem(2).propId = &H5103
    PropItem(2).Length = 1
    PropItem(2).type = PropertyTagTypeByte
    PropItem(2).Value = VarPtr(0)
    '  
    enc.Count = 1
    enc.Parameter.GUID = DEFINE_GUID(EncoderSaveFlag)
    enc.Parameter.NumberOfValues = 1
    enc.Parameter.type = EncoderParameterValueTypeLong
    enc.Parameter.Value = VarPtr(encvalue)
    '    
    encvalue = EncoderValueMultiFrame
    '   
    Me.MousePointer = 11
    DoEvents
    '   ,   
    If CreateStreamOnHGlobal(0&, True, IStream) Then MsgBox "Error on creating IStream": Exit Sub
    For i = 0 To ListCount - 1
        interval(i) = List(i).TimeMS \ 10
    Next
    '   
    ct = ListCount
    For i = 0 To ListCount - 1
        Me.Caption = "Process...(" & CStr(i + 1) & "/" & CStr(ct) & ")"
        itm = List(i)
        '   
        If GdipLoadImageFromFile(ByVal StrPtr(itm.FileName), img) Then
            MsgBox "Error load frame" & vbNewLine & itm.FileName
        Else
            '   256     
            If Not Conv256(img, itm.AlphaThreshold) Then
                MsgBox "Error convert palette in frame " & i & vbNewLine & "in file" & vbNewLine & itm.FileName
            End If
            '    ,    
            If i Then
                '   
                encvalue = EncoderValueFrameDimensionTime
                If GdipSaveAddImage(mimg, img, enc) Then
                    MsgBox "Error save frame " & i & vbNewLine & "in file" & vbNewLine & itm.FileName
                End If
                '   
                GdipDisposeImage img
            Else
                '   
                mimg = img
                '    
                GdipSetPropertyItem img, PropItem(0)
                '  - 
                GdipSetPropertyItem img, PropItem(1)
                GdipSetPropertyItem img, PropItem(2)
                '   
                If GdipSaveImageToStream(img, IStream, cls, enc) Then
                    MsgBox "Error save frame " & i & vbNewLine & nam
                    GoTo EndProcess
                End If
            End If
        End If
        DoEvents
    Next
    '   
    encvalue = EncoderValueFlush
    '  
    GdipSaveAdd mimg, enc
    If GetHGlobalFromStream(ObjPtr(IStream), hMem) Then MsgBox "Error query global memory": GoTo EndProcess
    '   
    sz = GlobalSize(hMem)
    '   0
    If sz > 0 Then
        '     
        pt = GlobalLock(hMem)
        If pt = 0 Then MsgBox "Error pointer": GoTo EndProcess
        '   
        If Not SetDispMode(pt, sz) Then GoTo EndProcess
        '  
        hFile = CreateFile(StrPtr(nam), GENERIC_WRITE, FILE_SHARE_READ, ByVal 0&, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
        If hFile = -1 Then
            MsgBox "Error creating output file"
        Else
            '   
            If WriteFile(hFile, ByVal pt, sz, 0, ByVal 0&) = 0 Then
                MsgBox "Error write data"
            End If
            '  
            CloseHandle hFile
        End If
        '     
        GlobalUnlock hMem
    Else: MsgBox "Null file size": GoTo EndProcess
    End If
EndProcess:
    '  1- 
    GdipDisposeImage mimg
    Me.MousePointer = 0
    Me.Caption = "GifMakerByTheTrick"
    '       
    Set IStream = Nothing
End Sub
' .. GDI+     Disposable mode  GIF     
'        ,   ""   
Private Function SetDispMode(ByVal pt As Long, ByVal Count As Long) As Boolean
    Dim ed As Long, hdr As String * 6, B As Byte, IsGIF89 As Boolean
    ed = Count + pt
    '  
    lstrcpyn ByVal hdr, ByVal pt, 7
    If StrComp(hdr, "GIF89a", vbTextCompare) = 0 Then
       IsGIF89 = True
    ElseIf StrComp(hdr, "GIF87a", vbTextCompare) Then
       MsgBox "Unsupported format"
       Exit Function
    End If
    '    
    GetMem1 ByVal pt + 10, B
    If B And &H80 Then pt = pt + 3 * (2 ^ ((B And &H7) + 1)) + 13 Else pt = pt + 13
    Do
       GetMem1 ByVal pt, B             '  
       If B = &H21 And IsGIF89 Then    '
           GetMem1 ByVal pt + 1, B     '  
           Select Case B
           Case &HFF                   '  
               pt = pt + 14
               Do: GetMem1 ByVal pt, B: pt = pt + B + 1: Loop While B '   
           Case &HFE                   '  
               pt = pt + 2
               Do: GetMem1 ByVal pt, B: pt = pt + B + 1: Loop While B '   
           Case &HF9                   '   
               GetMem1 ByVal pt + 3, B ' 
               B = (B And &HE3&) Or 8  '   
               GetMem1 B, ByVal pt + 3 ' 
               pt = pt + 8
           Case &H1                    '    
               pt = pt + 15
               Do: GetMem1 ByVal pt, B: pt = pt + B + 1: Loop While B '   
           Case Else
               MsgBox "Unsupported block in GIF file"
               Exit Function
           End Select
       ElseIf B = &H2C Then            ' ( )
           GetMem1 ByVal pt + 9, B     '  
           If B And &H80 Then          '  
               pt = pt + 3 * (2 ^ ((B And &H7) + 1)) + 11
           Else: pt = pt + 11
           End If
           Do: GetMem1 ByVal pt, B: pt = pt + B + 1: Loop While B '   
       ElseIf B = &H3B Then            ' 
           SetDispMode = True
           Exit Function
       Else                            ' 
           MsgBox "Unsupported block in GIF file"
           Exit Function
       End If
    Loop While pt < ed
End Function
'   256 
Private Function Conv256(Bitmap As Long, Threshold As Long) As Boolean
    Dim w As Long, h As Long
    Dim img8 As Long, str8 As Long, Pal As ColorPalette
    Dim pix32() As Byte, img32 As Long, str32 As Long, buf As Long
    Dim I1 As Long, I2 As Long, p1 As Long, p2 As Long, Tree As clsOctree, Col As RGBTriple
    Dim x As Long, y As Long, a As Long
    Static pix8() As Byte
    
    '   
    GdipGetImageWidth Bitmap, w: GdipGetImageHeight Bitmap, h
    '   8bbp 
    str8 = -Int(-w / 4) * 4
    ReDim pix8(str8 * h - 1)
    If GdipCreateBitmapFromScan0(w, h, str8, PixelFormat8bppIndexed, pix8(0), img8) Then
        MsgBox "Error create output bitmap"
        GoTo ErrorLabel
    End If
    '          32bpp
    str32 = w * 4
    ReDim pix32(str32 * h - 1)
    If GdipCreateBitmapFromScan0(w, h, str32, PixelFormat32bppARGB, pix32(0), img32) Then
        MsgBox "Error create output bitmap"
        GoTo ErrorLabel
    End If
    '  Graphics,    
    If GdipGetImageGraphicsContext(img32, buf) Then
        MsgBox "Error create output graphics"
        GoTo ErrorLabel
    End If
    '    
    If GdipDrawImageRectI(buf, Bitmap, 0, 0, w, h) Then
        MsgBox "Error draw to output graphics"
        GoTo ErrorLabel
    End If
    '       
    TreeSize = 0
    TreeReduceLevel = 7
    TreeLeafLevel = 8
    ReDim TreeReduceList(8)
    Set Tree = New clsOctree
    For I1 = 0 To UBound(pix32) Step 4
        Col.B = pix32(I1)
        Col.G = pix32(I1 + 1)
        Col.R = pix32(I1 + 2)
        Tree.AddTree Col, 0
        If TreeSize > 255 Then Tree.ReduceTree
    Next
    '     1-  ,   
    Pal.flags = PaletteFlagsHasAlpha
    '  
    Tree.GetPalette Pal.Entries(), 1
    Pal.Count = TreeSize + 1
    '    
    If GdipSetImagePalette(img8, Pal) Then
        MsgBox "Error assign palette"
        GoTo ErrorLabel
    End If
    '     
    I1 = 0: I2 = 0
    For y = 0 To h - 1
        p1 = I1: p2 = I2
        For x = 0 To w - 1
            Col.B = pix32(p1)
            Col.G = pix32(p1 + 1)
            Col.R = pix32(p1 + 2)
            a = pix32(p1 + 3)
            If a < Threshold Then
                pix8(p2) = 0
            Else
                pix8(p2) = Tree.GetNearestPaletteIndex(Col)
            End If
            p2 = p2 + 1: p1 = p1 + 4
        Next
        I1 = I1 + str32
        I2 = I2 + str8
    Next
    '  
    GdipDeleteGraphics buf
    GdipDisposeImage Bitmap
    GdipDisposeImage img32
    '  
    Bitmap = img8
    Erase pix32()
    Conv256 = True
    Exit Function
ErrorLabel:
    If img8 Then GdipDisposeImage img8
    If img32 Then GdipDisposeImage img32
    If buf Then GdipDeleteGraphics buf
    Erase pix32(): Erase pix8()
End Function
'  CLSID   
Private Function GetEncoderClsid(strMimeType As String, ClassID As CLSID) As Long
    Dim Num As Long, size As Long, i As Long, s As String, l As Long
    Dim ICI() As ImageCodecInfo
    Dim buffer() As Byte
    GetEncoderClsid = -1
    '       
    GdipGetImageEncodersSize Num, size
    If size = 0 Then Exit Function
    ReDim ICI(1 To Num) As ImageCodecInfo
    ReDim buffer(1 To size) As Byte
    '  
    GdipGetImageEncoders Num, size, buffer(1)
    CopyMemory ICI(1), buffer(1), (Len(ICI(1)) * Num)
    '      
    For i = 1 To Num
        l = lstrlen(ByVal ICI(i).MimeType)
        s = Space(l)
        lstrcpyn ByVal StrPtr(s), ByVal ICI(i).MimeType, l + 1
        If StrComp(s, strMimeType, vbTextCompare) = 0 Then
            ClassID = ICI(i).ClassID
            GetEncoderClsid = i
            Exit For
        End If
    Next
End Function
' CLSID    
Private Function DEFINE_GUID(ByVal sGuid As String) As CLSID
    Call CLSIDFromString(StrPtr(sGuid), DEFINE_GUID)
End Function
'  
Private Sub cmdUp_Click()
    Dim i As Long
    i = ListIndex
    If i >= 1 Then
        Swap i, i - 1
        ListIndex = i - 1
    End If
End Sub
'    
Private Sub Form_Initialize()
    Dim cc As INITCOMMONCONTROLSEX
    cc.dwSize = Len(cc)
    cc.dwICC = ICC_STANDARD_CLASSES
    INITCOMMONCONTROLSEX cc
End Sub
Private Sub Form_Load()
    Dim Prev As Long
    gi.GdiplusVersion = 1
    GdiplusStartup token, gi
    '   
    LastValidInterval = 100: LastValidLoopCount = 0: LastValidAlpha = 128
    '  
    CreateList
End Sub

Private Sub Form_Resize()
    If Me.WindowState <> vbMinimized Then
        ListMove CltSpacing, CltSpacing, Me.ScaleWidth - cmdAdd.Width - CltSpacing * 3, Me.ScaleHeight - CltSpacing * 2
        cmdAdd.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing
        cmdUp.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing, cmdAdd.Top + cmdAdd.Height + CltSpacing
        cmdDown.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing, cmdUp.Top + cmdUp.Height + CltSpacing
        cmdRemove.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing, cmdDown.Top + cmdDown.Height + CltSpacing
        cmdSave.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing, cmdRemove.Top + cmdRemove.Height + CltSpacing
        lblInterval.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing, cmdSave.Top + cmdSave.Height + CltSpacing
        txtInterval.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing, lblInterval.Top + lblInterval.Height + CltSpacing
        lblThreshold.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing, txtInterval.Top + txtInterval.Height + CltSpacing
        txtThreshold.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing, lblThreshold.Top + lblThreshold.Height + CltSpacing
        lblLoop.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing, txtThreshold.Top + txtThreshold.Height + CltSpacing
        txtLoop.Move Me.ScaleWidth - cmdAdd.Width - CltSpacing, lblLoop.Top + lblLoop.Height + CltSpacing
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim i As Long
    For i = 0 To ListCount - 1
        '   
        GdipDisposeImage List(i).img
    Next
    '  
    DeleteList
    GdiplusShutdown token
End Sub
' Str -> Long
Private Function GetTextValue(Text As String, Value As Long) As Boolean
    If Not Text Like "*[!0-9]*" Then
        Value = Val(Text)
        GetTextValue = True
    End If
End Function
'  
Private Sub txtInterval_Change()
    Dim itm As ListItem, v As Long
    If GetTextValue(txtInterval.Text, v) Then
        If v < 10 Then Exit Sub
        If ListIndex >= 0 Then
            itm = List(ListIndex)
            itm.TimeMS = v
            List(ListIndex) = itm
        End If
        LastValidInterval = v
    End If
End Sub
'  
Private Sub txtThreshold_Change()
    Dim itm As ListItem, v As Long
    If GetTextValue(txtThreshold.Text, v) Then
        If v < 0 Or v > 253 Then Exit Sub
        If ListIndex >= 0 Then
            itm = List(ListIndex)
            itm.AlphaThreshold = v
            List(ListIndex) = itm
        End If
        LastValidAlpha = v
    End If
End Sub
'  
Private Sub txtLoop_Change()
    Dim v As Long
    If GetTextValue(txtLoop.Text, v) Then
        If v < 0 Or v > 65535 Then Exit Sub
        LastValidLoopCount = v
    End If
End Sub
